/*
 * =============================================================
 * stayontop.c - stayontop feature on ms windows
 *
 * set a gui element stay on top
 *
 */

/*
 *   zum compilieren: "mex stayontop.c user32.lib"
 *
 */


#include "mex.h"
#include "matrix.h"
#include <windows.h>

 
bool stayontop(const unsigned char *name,bool *mode)
{
   HWND hwnd = NULL;
   //char clazz[]="com.mathworks.hg.peer.FigurePeer$FigureFrame"; // im Konfliktfall
   hwnd = FindWindow(NULL,name);
   if(hwnd==NULL) return false;

   if(*mode)
   {
        SetWindowPos(hwnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);       
   }
   else
   {
        SetWindowPos(hwnd,HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);                      
   }
   return true;   
}


void mexFunction(int nlhs, mxArray *plhs[],
                 int nrhs, const mxArray *prhs[])
{
  char *input_buf;
  int   buflen,status;
  mxLogical *pl,*p2;
    
  /* Check for proper number of arguments. */
  if (nrhs != 2) 
    mexErrMsgTxt("Two input required.");
  else if (nlhs > 1) 
    mexErrMsgTxt("Too many output arguments.");

  /* Input must be a string. */
  if (mxIsChar(prhs[0]) != 1)
    mexErrMsgTxt("Input1 must be a string.");
  
/* Input must be a string. */
  if ( mxIsLogicalScalar(prhs[1]) != 1)
    mexErrMsgTxt("Input2 must be a logical.");  
  
  p2=mxGetLogicals(prhs[1]);

  /* Input must be a row vector. */
  if (mxGetM(prhs[0]) != 1)
    mexErrMsgTxt("Input must be a row vector.");
    
  /* Get the length of the input string. */
  buflen = (mxGetM(prhs[0]) * mxGetN(prhs[0])) + 1;

  /* Allocate memory for input*/
  input_buf = mxCalloc(buflen, sizeof(char));
 
  /* Copy the string data from prhs[0] into a C string 
   * input_buf. */
  status = mxGetString(prhs[0], input_buf, buflen);
  if (status != 0) 
    mexWarnMsgTxt("Not enough space. String is truncated.");
    
  
  // Boolsche Ausgabe   
  plhs[0] = mxCreateLogicalMatrix(1,1);  
  pl = mxGetLogicals(plhs[0]);
  
  
  /* Call the C subroutine. */  
  *pl=stayontop(input_buf,p2);
      
}
